/*******************************************************************************
 * FoxDataProvider_Avatar generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDataProvider_Avatar extends FoxDataProvider_Gear_LowerBody
    transient
    native
    config(Avatar)
    perobjectconfig
    hidecategories(Object,UIRoot);

enum AvatarCamoType
{
    EACT_None,
    EACT_Single,
    EACT_Multiple,
    EACT_MAX
};

struct native MaterialSwapPaths
{
    var string OriginalMaterialPath;
    var string NewMaterialPath;

    structdefaultproperties
    {
        OriginalMaterialPath=""
        NewMaterialPath=""
    }
};

var config array<config MaterialSwapPaths> TPMaterialSwaps;
var config array<config MaterialSwapPaths> FPMaterialSwaps;
var config int VersionNumber;
var const config LinearColor OverlayColor;
var const config string FirstPersonArms;
var const config FoxDataProvider_Avatar.AvatarCamoType CamoType;
var const config array<config AvatarCamoInfo> AvatarCamos;
var const config bool bSupportsHeadshots;
var const config bool bFemale;
var const config array<config string> TPAnimSetName;
var const config array<config string> FPAnimSetName;

simulated function array<AnimSet> GetAdditionalFPAnimSets()
{
    local int I;
    local AnimSet TestSet;
    local array<AnimSet> AnimSetArray;

    I = 0;
    J0x0B:
    // End:0x93 [Loop If]
    if(I < FPAnimSetName.Length)
    {
        TestSet = AnimSet(DynamicLoadObject(FPAnimSetName[I], class'AnimSet', false));
        // End:0x85
        if(TestSet != none)
        {
            AnimSetArray.AddItem(TestSet);
            J0x85:
        }
        // End:0x85
        else
        {
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return AnimSetArray;
    //return ReturnValue;    
}

simulated function array<AnimSet> GetAdditionalTPAnimSets()
{
    local int I;
    local AnimSet TestSet;
    local array<AnimSet> AnimSetArray;

    I = 0;
    J0x0B:
    // End:0x93 [Loop If]
    if(I < TPAnimSetName.Length)
    {
        TestSet = AnimSet(DynamicLoadObject(TPAnimSetName[I], class'AnimSet', false));
        // End:0x85
        if(TestSet != none)
        {
            AnimSetArray.AddItem(TestSet);
            J0x85:
        }
        // End:0x85
        else
        {
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return AnimSetArray;
    //return ReturnValue;    
}

function SkeletalMesh GetSkelMeshAsset(bool bIsFemale, FoxPRI PRI)
{
    local SkeletalMesh ReturnMesh;

    // End:0x51
    if(!bIsFemale && MAssetPath != "")
    {
        ReturnMesh = SkeletalMesh(DynamicLoadObject(MAssetPath, class'SkeletalMesh', false));
    }
    // End:0xA0
    if(bIsFemale && FAssetPath != "")
    {
        ReturnMesh = SkeletalMesh(DynamicLoadObject(FAssetPath, class'SkeletalMesh', false));
    }
    return ReturnMesh;
    //return ReturnValue;    
}

simulated function bool SetFirstPersonSkeletalMesh(SkeletalMeshComponent SMC)
{
    local SkeletalMesh FPMesh;
    local string ObjectPath;
    local int I, J;
    local bool bFound;

    // End:0x40
    if(FirstPersonArms != "")
    {
        FPMesh = SkeletalMesh(DynamicLoadObject(FirstPersonArms, class'SkeletalMesh', false));
    }
    // End:0x78
    if(FPMesh != none)
    {
        SMC.SetSkeletalMesh(FPMesh);
    }
    I = 0;
    J0x83:
    // End:0x25A [Loop If]
    if(I < SMC.GetNumElements())
    {
        bFound = false;
        SMC.SetMaterial(I, none);
        ObjectPath = PathName(SMC.SkeletalMesh.Materials[I]);
        J = 0;
        J0x141:
        // End:0x215 [Loop If]
        if(J < FPMaterialSwaps.Length)
        {
            // End:0x207
            if(ObjectPath ~= FPMaterialSwaps[J].OriginalMaterialPath)
            {
                SMC.SetMaterial(I, MaterialInstanceConstant(DynamicLoadObject(FPMaterialSwaps[J].NewMaterialPath, class'MaterialInstanceConstant', false)));
                bFound = true;
                // [Explicit Break]
                goto J0x215;
            }
            ++ J;
            J0x215:
            // [Loop Continue]
            goto J0x141;
        }
        // End:0x24C
        if(!bFound)
        {
            SMC.CreateAndSetMaterialInstanceConstant(I);
        }
        ++ I;
        // [Loop Continue]
        goto J0x83;
    }
    return FPMesh != none;
    //return ReturnValue;    
}

function SetAvatarSkin(out SkeletalMeshComponent SMC, optional bool bPreview)
{
    local int I, J;
    local string ObjectPath;
    local MaterialInstanceConstant MIC;

    I = 0;
    J0x0C:
    // End:0x273 [Loop If]
    if(I < SMC.GetNumElements())
    {
        SMC.SetMaterial(I, none);
        ObjectPath = PathName(SMC.SkeletalMesh.Materials[I]);
        J = 0;
        J0xBE:
        // End:0x186 [Loop If]
        if(J < TPMaterialSwaps.Length)
        {
            // End:0x178
            if(ObjectPath ~= TPMaterialSwaps[J].OriginalMaterialPath)
            {
                SMC.SetMaterial(I, MaterialInstanceConstant(DynamicLoadObject(TPMaterialSwaps[J].NewMaterialPath, class'MaterialInstanceConstant', false)));
                // [Explicit Break]
                goto J0x186;
            }
            ++ J;
            J0x186:
            // [Loop Continue]
            goto J0xBE;
        }
        // End:0x265
        if(bPreview)
        {
            MIC = MaterialInstanceConstant(SMC.GetMaterial(I));
            // End:0x265
            if(MIC != none)
            {
                MIC.SetVectorParameterValue(class'FoxPawn'.default.EmissiveParamName, class'FoxTeamInfo'.default.FriendlyTeamEmissive);
                MIC.SetScalarParameterValue('ArmoryBloom', 1.0);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x0C;
    }
    class'FoxPawn'.static.SetAvatarCamo(SMC, self);
    //return;    
}

defaultproperties
{
    OverlayColor=(R=0.0,G=0.0,B=0.0,A=1.0)
}